/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingAccountMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingAccountMutable{}

// BillingAccountMutable struct for BillingAccountMutable
type BillingAccountMutable struct {
	Name string `json:"name"`
	Type *string `json:"type,omitempty"`
	TaxId *string `json:"tax_id,omitempty"`
	ContactInfo *BillingContactInfo `json:"contact_info,omitempty"`
	BillingAddress *ContactAddress `json:"billing_address,omitempty"`
}

// NewBillingAccountMutable instantiates a new BillingAccountMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingAccountMutable(name string) *BillingAccountMutable {
	this := BillingAccountMutable{}
	this.Name = name
	return &this
}

// NewBillingAccountMutableWithDefaults instantiates a new BillingAccountMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingAccountMutableWithDefaults() *BillingAccountMutable {
	this := BillingAccountMutable{}
	return &this
}

// GetName returns the Name field value
func (o *BillingAccountMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *BillingAccountMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *BillingAccountMutable) SetName(v string) {
	o.Name = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *BillingAccountMutable) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountMutable) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *BillingAccountMutable) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *BillingAccountMutable) SetType(v string) {
	o.Type = &v
}

// GetTaxId returns the TaxId field value if set, zero value otherwise.
func (o *BillingAccountMutable) GetTaxId() string {
	if o == nil || IsNil(o.TaxId) {
		var ret string
		return ret
	}
	return *o.TaxId
}

// GetTaxIdOk returns a tuple with the TaxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountMutable) GetTaxIdOk() (*string, bool) {
	if o == nil || IsNil(o.TaxId) {
		return nil, false
	}
	return o.TaxId, true
}

// HasTaxId returns a boolean if a field has been set.
func (o *BillingAccountMutable) HasTaxId() bool {
	if o != nil && !IsNil(o.TaxId) {
		return true
	}

	return false
}

// SetTaxId gets a reference to the given string and assigns it to the TaxId field.
func (o *BillingAccountMutable) SetTaxId(v string) {
	o.TaxId = &v
}

// GetContactInfo returns the ContactInfo field value if set, zero value otherwise.
func (o *BillingAccountMutable) GetContactInfo() BillingContactInfo {
	if o == nil || IsNil(o.ContactInfo) {
		var ret BillingContactInfo
		return ret
	}
	return *o.ContactInfo
}

// GetContactInfoOk returns a tuple with the ContactInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountMutable) GetContactInfoOk() (*BillingContactInfo, bool) {
	if o == nil || IsNil(o.ContactInfo) {
		return nil, false
	}
	return o.ContactInfo, true
}

// HasContactInfo returns a boolean if a field has been set.
func (o *BillingAccountMutable) HasContactInfo() bool {
	if o != nil && !IsNil(o.ContactInfo) {
		return true
	}

	return false
}

// SetContactInfo gets a reference to the given BillingContactInfo and assigns it to the ContactInfo field.
func (o *BillingAccountMutable) SetContactInfo(v BillingContactInfo) {
	o.ContactInfo = &v
}

// GetBillingAddress returns the BillingAddress field value if set, zero value otherwise.
func (o *BillingAccountMutable) GetBillingAddress() ContactAddress {
	if o == nil || IsNil(o.BillingAddress) {
		var ret ContactAddress
		return ret
	}
	return *o.BillingAddress
}

// GetBillingAddressOk returns a tuple with the BillingAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountMutable) GetBillingAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.BillingAddress) {
		return nil, false
	}
	return o.BillingAddress, true
}

// HasBillingAddress returns a boolean if a field has been set.
func (o *BillingAccountMutable) HasBillingAddress() bool {
	if o != nil && !IsNil(o.BillingAddress) {
		return true
	}

	return false
}

// SetBillingAddress gets a reference to the given ContactAddress and assigns it to the BillingAddress field.
func (o *BillingAccountMutable) SetBillingAddress(v ContactAddress) {
	o.BillingAddress = &v
}

func (o BillingAccountMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingAccountMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.TaxId) {
		toSerialize["tax_id"] = o.TaxId
	}
	if !IsNil(o.ContactInfo) {
		toSerialize["contact_info"] = o.ContactInfo
	}
	if !IsNil(o.BillingAddress) {
		toSerialize["billing_address"] = o.BillingAddress
	}
	return toSerialize, nil
}

type NullableBillingAccountMutable struct {
	value *BillingAccountMutable
	isSet bool
}

func (v NullableBillingAccountMutable) Get() *BillingAccountMutable {
	return v.value
}

func (v *NullableBillingAccountMutable) Set(val *BillingAccountMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingAccountMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingAccountMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingAccountMutable(val *BillingAccountMutable) *NullableBillingAccountMutable {
	return &NullableBillingAccountMutable{value: val, isSet: true}
}

func (v NullableBillingAccountMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingAccountMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


